/*
 * hello.c -- A simple "Hello, World" sample Windows program for PureCoverage.
 *
 * Licensed Materials - Use restricted, please refer to the "Samples" terms and 
 * conditions in the IBM International Program License Agreement (IPLA).  
* (C) Copyright IBM Corporation. 1995, 2006. All Rights Reserved.
 *
 */

#include <windows.h>

void DisplayLocalTime(int nDisplayFlag) /* Displays the time of day in a message box */
{
	SYSTEMTIME SystemTime;
	char buf[30];
	int RetCode;

	GetLocalTime(&SystemTime);
	RetCode = wsprintf (buf, "%s%d%s%.2d%s%.2d%s", "Currently ", SystemTime.wHour, ":",
	                                                   SystemTime.wMinute, ":",
	                                                   SystemTime.wSecond, " ");
	if (nDisplayFlag && ((int)strlen(buf) == RetCode))
	{
		MessageBox(NULL, buf, "Local Time of Day",
		           MB_OK | MB_ICONINFORMATION);
	}
}

WINAPI
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{
	int i, RetVal = MessageBox(NULL,"Do you want to see the time of day?","Hello, World",
	                           MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2);

	if (RetVal == IDYES)
	{
		for (i = 0; i < 2; i++)
		{
			DisplayLocalTime(i);
		}
	}
	else 
	{
		/* do nothing */
		return 0;
	}

	return 1;
}
