////////////////////////////////////////////////////////////////////////////////
// FasterActX ActiveX Demonstration Program For Quantify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
// FasterActXATL.cpp : Implementation of CMyFasterActXATL

#include "stdafx.h"
#include "FasterActX.h"
#include "FasterActXATL.h"

// if you change these defines, also update the values in VQDemoCon\VQDemoCon1.h 
#define FASTWIDTH	472
#define FASTHEIGHT	407

/////////////////////////////////////////////////////////////////////////////
// CMyFasterActXATL

CMyFasterActXATL::CMyFasterActXATL()
{
	AfxEnableControlContainer();
	m_bAutoSize = FALSE;

	// Set the initial size
	SIZEL sizeInPix;
	sizeInPix.cx = FASTWIDTH;
	sizeInPix.cy = FASTHEIGHT;
	AtlPixelToHiMetric(&sizeInPix, &m_sizeExtent);
	// Make sure the natural extent is the correct size too
	m_sizeNatural = m_sizeExtent;

	AfxSetResourceHandle(_Module.GetResourceInstance());
	afxCurrentInstanceHandle = _Module.GetModuleInstance();
}

HRESULT CMyFasterActXATL::OnDraw(ATL_DRAWINFO& di)
{
	RECT& rc = *(RECT*)di.prcBounds;
	Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);
	//fix for painting problem in IE 4.0 prev2
	m_FasterActXCtrl.OnDraw(di);
	return S_OK;
}

HWND CMyFasterActXATL::CreateControlWindow(HWND hWndParent, RECT& rcPos)
{
	if (TRUE==m_FasterActXCtrl.m_Initialized)
	{
		//********************************************************************
		// NOTE: PROTECTION against multiple invocations if and when IE 4.0
		// changes its behavior to be consistent with tstcon32.exe and IE 3.02
		//********************************************************************
		return m_ControlHwnd;
	}
	///********************************************************************************
	// should be but does not link: 
	// HWND hwnd = CComControlBase::CreateControlWindow(hWndParent, rcPos);
	// IS and does compile and link:
	CMyFasterActXATL* pT = static_cast<CMyFasterActXATL*>(this);
	m_ControlHwnd =  pT->Create(hWndParent, rcPos);
	// as done in \devstudio\vc\atl\include\atlctl.cpp
	///********************************************************************************

	CRect rect(0, 0, rcPos.right-rcPos.left, rcPos.bottom-rcPos.top);
	m_FasterActXCtrl.Create(m_ControlHwnd, rect);
	m_FasterActXCtrl.ShowWindow(SW_NORMAL);
	return m_ControlHwnd;
}


HRESULT CMyFasterActXATL::InPlaceActivate(LONG iVerb, const RECT* prcPosRect)
{
	HRESULT hr;

	hr = CComControlBase::InPlaceActivate(iVerb, prcPosRect);
	ATLTRACE(_T("InPlaceActivate\n"));
	//********************************************************************
	// NOTE: IE 3.02 and tstcon32.exe InPlaceActive() will call
	// CreateControlWindow() which we have overwritten. On IE 4.0, this
	// does not occur?!
	HWND hWndParent;
	if (m_spInPlaceSite &&
		S_OK==m_spInPlaceSite->GetWindow(&hWndParent))
	{
		OLEINPLACEFRAMEINFO frameInfo;
		RECT rcPos, rcClip;
		CComPtr<IOleInPlaceFrame> spInPlaceFrame;
		CComPtr<IOleInPlaceUIWindow> spInPlaceUIWindow;
		frameInfo.cb = sizeof(OLEINPLACEFRAMEINFO);
		m_spInPlaceSite->GetWindowContext(&spInPlaceFrame,
										  &spInPlaceUIWindow,
										  &rcPos, 
										  &rcClip, 
										  &frameInfo);
		CreateControlWindow(hWndParent, rcPos);
	}
	//********************************************************************
	return hr;
}


STDMETHODIMP CMyFasterActXATL::InPlaceDeactivate(void)
{
	ATLTRACE(_T("InPlaceDeactivate\n"));
	m_FasterActXCtrl.DestroyWindow();
	return IOleInPlaceObjectWindowlessImpl<CMyFasterActXATL>::InPlaceDeactivate();
}

//*********************************************************************************
// Having trouble implementing IObjectSafety. 
// IE keeps telling me that my controls isn't safe. Why?
// Below is some code that I got from the ATL list 
// (Thanks to philip.lee@MULTITHREAD.CO.UK) via Tom Armstrong

// IObjectSafety implementation
STDMETHODIMP CMyFasterActXATL::GetInterfaceSafetyOptions( REFIID riid, DWORD *pdwSupportedOptions, DWORD *pdwEnabledOptions )

{
	UNREFERENCED_PARAMETER(riid);
	ATLTRACE(_T("CMyFasterActXATL::GetInterfaceSafetyOptions()\n"));

	*pdwSupportedOptions = INTERFACESAFE_FOR_UNTRUSTED_CALLER |
						 INTERFACESAFE_FOR_UNTRUSTED_DATA;
	*pdwEnabledOptions = *pdwSupportedOptions;
	return S_OK;
}

STDMETHODIMP CMyFasterActXATL::SetInterfaceSafetyOptions(REFIID riid, DWORD dwOptionSetMask, DWORD dwEnabledOptions)
{
	UNREFERENCED_PARAMETER(riid);
	UNREFERENCED_PARAMETER(dwOptionSetMask);
	UNREFERENCED_PARAMETER(dwEnabledOptions);
	ATLTRACE(_T("CMyFasterActXATL::SetInterfaceSafetyOptions\n"));
	return S_OK;
}
//*********************************************************************************
