////////////////////////////////////////////////////////////////////////////////
// FasterActX ActiveX Demonstration Program For Quantify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
// FasterActXATL.h : Declaration of the CMyFasterActXATL

#ifndef __FASTERACTXATL_H_
#define __FASTERACTXATL_H_

#include "resource.h"       // main symbols
#include "FasterActXCtrl.h"	// for class FasterActXCtrl

/////////////////////////////////////////////////////////////////////////////
// CMyFasterActXATL
class ATL_NO_VTABLE CMyFasterActXATL : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMyFasterActXATL, &CLSID_FasterActXATL>,
	public CComControl<CMyFasterActXATL>,
	public CStockPropImpl<CMyFasterActXATL, IMyFasterActXATL, &IID_IMyFasterActXATL, &LIBID_FASTERACTXLib>,
	public IProvideClassInfo2Impl<&CLSID_FasterActXATL, NULL, &LIBID_FASTERACTXLib>,
	public IPersistStreamInitImpl<CMyFasterActXATL>,
	public IPersistStorageImpl<CMyFasterActXATL>,
	public IQuickActivateImpl<CMyFasterActXATL>,
	public IOleControlImpl<CMyFasterActXATL>,
	public IOleObjectImpl<CMyFasterActXATL>,
	public IOleInPlaceActiveObjectImpl<CMyFasterActXATL>,
	public IViewObjectExImpl<CMyFasterActXATL>,
	public IOleInPlaceObjectWindowlessImpl<CMyFasterActXATL>,
	public IDataObjectImpl<CMyFasterActXATL>,
	public ISpecifyPropertyPagesImpl<CMyFasterActXATL>,
	public CDynamicChain,
	public IObjectSafety
{
public:
	CMyFasterActXATL();

DECLARE_REGISTRY_RESOURCEID(IDR_FASTERACTXATL)

BEGIN_COM_MAP(CMyFasterActXATL)
	COM_INTERFACE_ENTRY(IMyFasterActXATL)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL(IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject2, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY_IMPL(IOleControl)
	COM_INTERFACE_ENTRY_IMPL(IOleObject)
	COM_INTERFACE_ENTRY_IMPL(IQuickActivate)
	COM_INTERFACE_ENTRY_IMPL(IPersistStorage)
	COM_INTERFACE_ENTRY_IMPL(IPersistStreamInit)
	COM_INTERFACE_ENTRY_IMPL(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY_IMPL(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(IObjectSafety)
END_COM_MAP()

BEGIN_PROPERTY_MAP(CMyFasterActXATL)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	PROP_PAGE(CLSID_StockColorPage)
END_PROPERTY_MAP()


BEGIN_MSG_MAP(CMyFasterActXATL)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_KILLFOCUS, OnKillFocus)
END_MSG_MAP()


// IViewObjectEx
	STDMETHOD(GetViewStatus)(DWORD* pdwStatus)
	{
		ATLTRACE(_T("IViewObjectExImpl::GetViewStatus\n"));
		*pdwStatus = VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE;
		return S_OK;
	}

// IMyFasterActXATL
public:
	HRESULT OnDraw(ATL_DRAWINFO& di);
// customizations
public:
	virtual HWND	CreateControlWindow(HWND hWndParent, RECT& rcPos);
	STDMETHOD		(InPlaceActivate)(LONG iVerb, const RECT* prcPosRect = NULL);
	STDMETHOD		(InPlaceDeactivate)(void);
   // IObjectSafety implementation
	STDMETHOD		(GetInterfaceSafetyOptions)(REFIID riid, DWORD *pdwSupportedOptions, DWORD *pdwEnabledOptions);
	STDMETHOD		(SetInterfaceSafetyOptions)(REFIID riid, DWORD dwOptionSetMask, DWORD dwEnabledOptions);

	CMyFasterActXCtrl	m_FasterActXCtrl;
	HWND			m_ControlHwnd;
};

#endif //__FASTERACTXATL_H_
