////////////////////////////////////////////////////////////////////////////////
// FasterActX ActiveX Demonstration Program For Quantify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
// FastActXCtrl.cpp : Implementation of CMyFastActXCtrl

#include "stdafx.h"
#include "FasterActXCtrl.h"	// for class CMyFasterActXCtrl

/////////////////////////////////////////////////////////////////////////////
// CMyFasterActXCtrl

CMyFasterActXCtrl::CMyFasterActXCtrl()
{
	m_pPropertySheet	= NULL;
	m_pPageCubeMatrix	= NULL;
	m_pPageCubeThread	= NULL;
	m_Initialized		= NULL;
}

CMyFasterActXCtrl::~CMyFasterActXCtrl()
{
	if (NULL!=m_pPageCubeMatrix)
	{
		delete m_pPageCubeMatrix;
		m_pPageCubeMatrix = NULL;
	}
	if (NULL!=m_pPropertySheet)
	{
		delete m_pPropertySheet;
		m_pPropertySheet = NULL;
	}
	if (NULL!=m_pPageCubeThread)
	{
		delete m_pPageCubeThread;
		m_pPageCubeThread = NULL;
	}
}

HWND CMyFasterActXCtrl::Create(HWND hWndParent,
							   RECT& rcPos,
							   LPCTSTR szWindowName,
							   DWORD dwStyle,
							   DWORD dwExStyle,
							   UINT nID)
{
	m_Initialized = TRUE;
	ATOM atom = CMyFasterActXCtrl::GetWndClassInfo().Register(&m_pfnSuperWindowProc);
	HWND hWnd = CWindowImplBase::Create(hWndParent,
									    rcPos,
									    szWindowName,
									    dwStyle,
									    dwExStyle,
										nID,
										atom);
	m_PvtWnd.Attach(hWnd);

	// alloc the MFC property sheet object
	m_pPropertySheet = new CPropertySheet;
	m_pPropertySheet->EnableStackedTabs(TRUE);		// disable tab scrolling

	// add your pages here!
	m_pPageCubeMatrix = new CMyPageCubeMatrix;
	m_pPageCubeMatrix->SetSheet(m_pPropertySheet);
	m_pPageCubeMatrix->SetTabIcon(IDI_QUANTIFY);
	m_pPropertySheet->AddPage(m_pPageCubeMatrix);

	m_pPageCubeThread = new CMyPageCubeThread;
	m_pPageCubeThread->SetSheet(m_pPropertySheet);
	m_pPageCubeThread->SetTabIcon(IDI_QUANTIFY);
	m_pPropertySheet->AddPage(m_pPageCubeThread);

	// create a modeless property page
	if (!m_pPropertySheet->Create(&m_PvtWnd,
			DS_CONTEXTHELP | DS_SETFONT | WS_CHILD | WS_VISIBLE))
	{
		return hWnd;
	}

	// resize the tab control to the size of its place holder
	CRect rect;
	m_PvtWnd.GetClientRect(&rect);
	m_pPropertySheet->SetWindowPos(NULL, 0, 0, rect.Width(), rect.Height()+1,
			SWP_NOACTIVATE | SWP_NOZORDER);

	ModifyStyleEx(0, WS_EX_CONTROLPARENT);

	return hWnd;
}

BOOL CMyFasterActXCtrl::DestroyWindow()
{
	// must detach private window or access violation will result
	// during destruction of this object.
	m_PvtWnd.Detach();

	if (m_hWnd)
	{
		if (!::DestroyWindow(m_hWnd))
		{
			return FALSE;
		}

		m_hWnd = NULL;
		return TRUE;
	} else {
		return FALSE;
	}
}

HRESULT CMyFasterActXCtrl::OnDraw(ATL_DRAWINFO& di)
{
	//fix for painting problem in IE 4.0 prev2
	m_pPropertySheet->Invalidate();
	return S_OK;
}
