////////////////////////////////////////////////////////////////////////////////
// FasterActX ActiveX Demonstration Program For Quantify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
// FasterActXCtrl.h : Declaration of the CMyFasterActXCtrl

#ifndef __FASTERACTXCTRL_H_
#define __FASTERACTXCTRL_H_

#include "resource.h"       // main symbols
#include "PageCubeMatrix.h"	// for class CMyPageCubeMatrix
#include "PageCubeThread.h"	// for class CMyPageCubeThread

/////////////////////////////////////////////////////////////////////////////
// CMyFastActXCtrl
class CMyFasterActXCtrl : 
	public CWindowImpl<CMyFasterActXCtrl>
{
public:
	CMyFasterActXCtrl();
	~CMyFasterActXCtrl();
	BOOL	m_Initialized;


// Overrides
	virtual	HWND Create(HWND hWndParent, RECT& rcPos, LPCTSTR szWindowName = NULL,
				DWORD dwStyle = WS_CHILD | WS_VISIBLE, DWORD dwExStyle = 0,
				UINT nID = 0);
	virtual BOOL	DestroyWindow();
	HRESULT OnDraw(ATL_DRAWINFO& di);

	BEGIN_MSG_MAP(CMyFasterActXCtrl)
	END_MSG_MAP()

protected:
	CWnd				m_PvtWnd;
	CPropertySheet*		m_pPropertySheet;
	CMyPageCubeMatrix*	m_pPageCubeMatrix;
	CMyPageCubeThread*	m_pPageCubeThread;
};

#endif //__FASTERACTXCTRL_H_
