////////////////////////////////////////////////////////////////////////////////
// FasterActX ActiveX Demonstration Program For Quantify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
// PagePropEx.h : header file

#ifndef PAGEPROPEX_H
#define	PAGEPROPEX_H

#include <afxdlgs.h>	// for class CPropertyPage

class CMyPropertyPageEx : public CPropertyPage
{
	DECLARE_DYNCREATE(CMyPropertyPageEx)

// Construction
public:
	CMyPropertyPageEx(UINT nIDTemplate = 0);
	CMyPropertyPageEx(CPropertySheet* pSheet, const UINT nIDTemplate, UINT nIDCaption = 0);
	CMyPropertyPageEx(CPropertySheet* pSheet, const UINT nIDTemplate, const CString& pszCaption);
	~CMyPropertyPageEx();

	void SetSheet(CPropertySheet* pSheet);
	void SetTabText(const CString& pszText);
	void SetTabIcon(const HICON hIcon);
	void SetTabIcon(const UINT resourceId);

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CMyPropertyPageEx)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

// Implementation
private:
	CPropertySheet* m_pSheet;

protected:
	// Generated message map functions
	//{{AFX_MSG(CMyPropertyPageEx)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#endif // PAGEPROPEX_H
/////////////////////////////////////////////////////////////////////////////
