////////////////////////////////////////////////////////////////////////////////
// FasterActX ActiveX Demonstration Program For Quantify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Jeff Prosise, Alan S. Cooper and Sean Echevarria
//
// Based on an article by Jeff Prosise that originally appeared in Microsoft 
// Systems Journal,  November 1994 - Vol 9 No 11
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
// CubeMatrix.h : header file

#ifndef CubeMatrix_H
#define CubeMatrix_H

#if !defined(AFX_CUBEMATRIX_H__583B9C81_D0AC_11D0_83B3_00A024E0C36F__INCLUDED_)
#define AFX_CUBEMATRIX_H__583B9C81_D0AC_11D0_83B3_00A024E0C36F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// CubeMatrix.h : header file
//

#include <GL/gl.h>			// for OpenGL api
#include <GL/glu.h>			// for OpenGL api

/////////////////////////////////////////////////////////////////////////////
// CMyCubeMatrix window

class CMyCubeMatrix : public CWnd
{
// Construction
public:
	CMyCubeMatrix(const UINT pt = 250, const BOOL job1 = TRUE, const BOOL loop = TRUE);

// Attributes
protected:
    UINT		m_nAngle;
	UINT		m_nTimer;
	HGLRC		m_hrc;
	CDC			*m_pcdc;
	HPALETTE	m_hPalette;
	BOOL		m_loop;
	UINT		m_paints;
	UINT		m_paintsDone;
	UINT		m_elapse;
	int			m_rgbVal;
    GLfloat		m_glfMaterialColor[4];
    GLfloat		m_glfModifier0;
    GLfloat		m_glfModifier2;
	BOOL		m_fastwork;

// Operations
public:
	void SetPaintMethod( BOOL );
	void SetRepetitiveJob( BOOL );
	UINT SetPaintCount( UINT );
	UINT ChangeTimer( UINT );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMyCubeMatrix)
	//}}AFX_VIRTUAL

// Implementation
	virtual ~CMyCubeMatrix();

	// Generated message map functions
protected:
	//{{AFX_MSG(CMyCubeMatrix)
	afx_msg void OnPaint();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	afx_msg BOOL OnQueryNewPalette( );
	afx_msg void OnPaletteChanged( CWnd* pFocusWnd );
	
	void Paint3DLoop(void);
	void Paint3DRecursive(int, int, int);
	void SetDCPixelFormat (void);
	void InitializeRC (void);
	void CreateDisplayList (void);
	void ModifyGLf (void);  
	void RepetitiveJob1(void);
	void RepetitiveJob2(void);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CUBEMATRIX_H__583B9C81_D0AC_11D0_83B3_00A024E0C36F__INCLUDED_)
#endif
