////////////////////////////////////////////////////////////////////////////////
// FasterActX ActiveX Demonstration Program For Quantify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
// PageCubeMatrix.h : header file

#ifndef PAGECUBEMATRIX_H
#define PAGECUBEMATRIX_H

#include "resource.h"		// for IDD_PAGE_OPENGL
#include "FasterActX.h"		// for class CMyPerformActXApp
#include "PagePropEx.h"		// for class CMyPropertyPageEx
#include "CubeMatrix.h"		// for class CMyCubeMatrix
#include "Edit.h"			// for class CMyEdit

/////////////////////////////////////////////////////////////////////////////
// CMyPageCubeMatrix dialog

class CMyPageCubeMatrix : public CMyPropertyPageEx
{
// Construction
public:
	CMyPageCubeMatrix(void);    // standard constructor
	~CMyPageCubeMatrix(void);   // standard destructor

	void OnStop();			// callback for cube notification

private:
// Dialog Data
	//{{AFX_DATA(CMyPageCubeMatrix)
	enum { IDD = IDD_PAGE_OPENGL };
	CButton			m_runButton;
	CButton			m_slowBox;
	CMyEdit			m_paintEdit;
	CWnd			m_demoWnd;
	UINT			m_paints;
	BOOL			m_slow;
	CString			m_InstructBox;
	//}}AFX_DATA

	CMyCubeMatrix	*m_CubeMatrix;
	RECT			m_rect;
	BOOL			m_isRunning;
	CFont			m_font;

public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	//{{AFX_VIRTUAL(CMyPageCubeMatrix)
	public:
	virtual BOOL OnKillActive();
	protected:
	virtual BOOL OnSetActive();
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

public:
	// Generated message map functions
	//{{AFX_MSG(CMyPageCubeMatrix)
	afx_msg void OnRun();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void SetControls(BOOL);
};

#endif //PAGECUBEMATRIX_H
/////////////////////////////////////////////////////////////////////////////
