////////////////////////////////////////////////////////////////////////////////
// FasterActX ActiveX Demonstration Program For Quantify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
// PageCubeThread.h : header file

#ifndef PAGECUBETHREAD_H
#define PAGECUBETHREAD_H

#include <afxcmn.h>			// for class CSpinButtonCtrl
#include "resource.h"		// for IDD_PAGE_OPENGL
#include "FasterActX.h"		// for class CMyPerformActXApp
#include "PagePropEx.h"		// for class CMyPropertyPageEx
#include "SpinCube.h"		// for class CMySpinCube

/////////////////////////////////////////////////////////////////////////////
// CMyPageCubeThread dialog

class CMyPageCubeThread : public CMyPropertyPageEx
{
// Construction
public:
	CMyPageCubeThread(void);    // standard constructor
	~CMyPageCubeThread(void);   // standard destructor

	void OnStop();			// callback for cube notification

private:
// Dialog Data
	//{{AFX_DATA(CMyPageCubeThread)
	enum { IDD = IDD_PAGE_THREAD };
	CButton		m_optionBox;
	CButton		m_runButton;
	CWnd		m_demoWnd;
	BOOL		m_option;
	CString		m_InstructBox;
	//}}AFX_DATA

	CMySpinCube		*m_SpinCube;
	CString			m_help;
	RECT			m_rect;
	BOOL			m_isRunning;
	CFont			m_font;

public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	//{{AFX_VIRTUAL(CMyPageCubeThread)
	public:
	virtual BOOL OnKillActive();
	protected:
	virtual BOOL OnSetActive();
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

public:
	// Generated message map functions
	//{{AFX_MSG(CMyPageCubeThread)
	afx_msg void OnRun();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#endif //PAGECUBETHREAD_H
/////////////////////////////////////////////////////////////////////////////
