////////////////////////////////////////////////////////////////////////////////
// FasterActX ActiveX Demonstration Program For Quantify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
#ifndef _SPINCUBE_H
#define _SPINCUBE_H

#if !defined(AFX_SPINCUBE_H__F1E8CB02_FED5_11D0_83CB_00A024E0C36F__INCLUDED_)
#define AFX_SPINCUBE_H__F1E8CB02_FED5_11D0_83CB_00A024E0C36F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "resource.h"       // main symbols
#include <afx.h>
#include <afxmt.h>

#include <GL/gl.h>			// for OpenGL api
#include <GL/glu.h>			// for OpenGL api

#pragma comment(lib, "opengl32.lib")
#pragma comment(lib, "glu32.lib")
#pragma comment(lib, "glaux.lib")

// SpinCube.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMySpinCube window

class CMySpinCube : public CWnd
{
// Construction
public:
	CMySpinCube(BOOL sync);
	virtual ~CMySpinCube();

	void StopDrawing();

protected:
	float		m_fRadius;
	BOOL		m_bMouseCaptured;
	int			m_xPos;
	int			m_yPos;
	LOGPALETTE	*m_pPal;

	BOOL		m_bActive;
	RECT		m_hrcTxt;
	CPalette	m_palette;
	HANDLE		m_hThreads[2];
	DWORD		m_threadIDs[2];
	BOOL		m_useUnLock;
	BOOL		m_sync;
	BOOL		m_setNewContext;
	HANDLE		m_hMutex;

// Attributes

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMySpinCube)
	//}}AFX_VIRTUAL

// Implementation
	// Generated message map functions
	//{{AFX_MSG(CMySpinCube)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

protected:
	void CreateContext(CDC *cdc, HGLRC& glrc);
	void CreateRGBPalette(CDC *dc);
	unsigned char ComponentFromIndex(int i, UINT nbits, UINT shift);
	BOOL bSetupPixelFormat(HDC hdc);

	// the drawing threads
	static void DrawOurText(CMySpinCube *);
	static void DrawOurCubeAndGrid(CMySpinCube *);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SPINCUBE_H__F1E8CB02_FED5_11D0_83CB_00A024E0C36F__INCLUDED_)

#endif
